<?php 
/**
 * this is where we check if the plugin is set to operate in the designated country
 * 
 */

class ModelExtensionPaymentAdumo extends Model {
    public function getMethod($address,$total) {
        $this->load->language('extension/payment/adumo');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_adumo_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if ($this->config->get('payment_adumo_total') > 0 && $this->config->get('payment_adumo_total') > $total) {
			$status = false;
		} elseif (!$this->config->get('payment_adumo_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'adumo',
				'title'      => $this->language->get('text_title'),
				'terms'      => '',
				'sort_order' => $this->config->get('payment_adumo_sort_order')
			);
		}

		return $method_data;
    }

	public function recurringPayments() {
		/*
		 * Used by the checkout to state the module
		 * supports recurring recurrings.
		 */
		return false;
	}

	/**
     * This method will check if the customer ID exists in our TABLE. If it does
     * exist then the token will be returned, otherwise a falsey value will be
     * returned.
     */
    public function getPaymentToken($customer_id){
        if(is_string($customer_id)){
            $customer_id = htmlspecialchars($customer_id);
			$query ="SELECT `token` from `" . DB_PREFIX . "adumo_order` WHERE `customer_id`='" . $customer_id . "' LIMIT 1;";
            $result = $this->db->query($query);
            return $result->num_rows>0 ? $result->row['token'] : false;
        }
        else
            return FALSE;
    }

    /**
     * This method will first check if the customer ID already exists in our TABLE.
     * If the customer does exist then they will have their token and payment method
     * updated, otherwise they will have a new record inserted.  
     */
    public function addPaymentToken($customer_id,$token,$payment_method){
        if(is_string($customer_id) && $customer_id && is_string($token) && is_string($payment_method)){
            $customer_id = htmlspecialchars($customer_id);
            $token = htmlspecialchars($token);
            $payment_method = htmlspecialchars($payment_method);

            $query = "SELECT * FROM `". DB_PREFIX ."adumo_order` WHERE `customer_id`='".$customer_id."';";
            $result = $this->db->query($query);
            /** 
             * if the customer ID already exists then update the payment_method
             * otherwise insert as a new record
             */
            if($result->num_rows>0){
                $row = $result->row;
				if($row['token']!=$token || $result->row['payment_method']!=$payment_method){
					$query = "UPDATE `".DB_PREFIX."`
					SET `payment_method`='".$payment_method."', `token`='".$token."' 
					WHERE `customer_payment_token_id`='".$row['customer_payment_token_id']."' ;";
					$result = $this->db->query($query);
				}
				else
					$result=TRUE;
            }
            else{
                $query = "INSERT INTO `".DB_PREFIX."adumo_order` (`customer_id`,`payment_method`,`token`) VALUES ('".$customer_id."','".$payment_method."','".$token."')";
                $result = $this->db->query($query);
            }

            return $result===TRUE ? TRUE : FALSE;
        }
        else
            return FALSE;
        
    }
}
